test-lib.sh: do not barf under --debug at the end of the test
[git/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
3c8f12c9
JH
18# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
85176d72
FC
26else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
30fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
2006f0ad
RR
39################################################################
40# It appears that people try to run tests without building...
41"$GIT_BUILD_DIR/git" >/dev/null
42if test $? != 1
43then
44 echo >&2 'error: you do not seem to have built git yet.'
45 exit 1
46fi
47
3c8f12c9
JH
48. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
49export PERL_PATH SHELL_PATH
50
4cde519f
RR
51# if --tee was passed, write the output not only to the terminal, but
52# additionally to the file test-results/$BASENAME.out, too.
53case "$GIT_TEST_TEE_STARTED, $* " in
54done,*)
55 # do not redirect again
56 ;;
452320f1 57*' --tee '*|*' --va'*|*' --verbose-log '*)
2d14e13c
JK
58 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
59 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
452320f1
JK
60
61 # Make this filename available to the sub-process in case it is using
62 # --verbose-log.
63 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
64 export GIT_TEST_TEE_OUTPUT_FILE
65
66 # Truncate before calling "tee -a" to get rid of the results
67 # from any previous runs.
68 >"$GIT_TEST_TEE_OUTPUT_FILE"
69
4cde519f 70 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
452320f1 71 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
925bdc92 72 test "$(cat "$BASE.exit")" = 0
4cde519f
RR
73 exit
74 ;;
75esac
76
e1970ce4 77# For repeatability, reset the environment to known value.
d5c1b7c2 78# TERM is sanitized below, after saving color control sequences.
e1970ce4 79LANG=C
899460f3 80LC_ALL=C
d9bdd39e 81PAGER=cat
e1970ce4 82TZ=UTC
d5c1b7c2 83export LANG LC_ALL PAGER TZ
8ff99e74 84EDITOR=:
661bfd13
SL
85# A call to "unset" with no arguments causes at least Solaris 10
86# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
87# deriving from the command substitution clustered with the other
88# ones.
3c8f12c9 89unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 90 my @env = keys %ENV;
730477f1
JL
91 my $ok = join("|", qw(
92 TRACE
93 DEBUG
94 USE_LOOKUP
95 TEST
96 .*_TEST
97 PROVE
98 VALGRIND
ac001282 99 UNZIP
edb54081 100 PERF_
e2a0ccc0 101 CURL_VERBOSE
4527aa10 102 TRACE_CURL
730477f1
JL
103 ));
104 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
105 print join("\n", @vars);
106')
5adf84eb 107unset XDG_CONFIG_HOME
8bade1e1 108unset GITPERLLIB
29e55cd5
JH
109GIT_AUTHOR_EMAIL=author@example.com
110GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
111GIT_COMMITTER_EMAIL=committer@example.com
112GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 113GIT_MERGE_VERBOSITY=5
f8246281
JH
114GIT_MERGE_AUTOEDIT=no
115export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
116export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
117export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 118export EDITOR
e1970ce4 119
124647c4
KB
120# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
121GIT_TRACE_BARE=1
122export GIT_TRACE_BARE
123
5d9fc888
TG
124if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
125then
126 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
127 export GIT_INDEX_VERSION
128fi
129
a731fa91
EP
130# Add libc MALLOC and MALLOC_PERTURB test
131# only if we are not executing the test with valgrind
1b3185fc 132if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 133 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
134then
135 setup_malloc_check () {
136 : nothing
137 }
138 teardown_malloc_check () {
139 : nothing
140 }
141else
142 setup_malloc_check () {
143 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
144 export MALLOC_CHECK_ MALLOC_PERTURB_
145 }
146 teardown_malloc_check () {
147 unset MALLOC_CHECK_ MALLOC_PERTURB_
148 }
149fi
a731fa91 150
b0f4c908
JK
151: ${ASAN_OPTIONS=detect_leaks=0}
152export ASAN_OPTIONS
153
886a3907
JH
154# Protect ourselves from common misconfiguration to export
155# CDPATH into the environment
156unset CDPATH
157
5565f47c 158unset GREP_OPTIONS
ac001282 159unset UNZIP
5565f47c 160
3d5c0cc9 161case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756 1621|2|true)
025232e8 163 GIT_TRACE=4
1c0cc756 164 ;;
6ce4e61f
CC
165esac
166
cd3c095c
JH
167# Convenience
168#
169# A regexp to match 5 and 40 hexdigits
170_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
171_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
172
3749fde5
JH
173# Zero SHA-1
174_z40=0000000000000000000000000000000000000000
175
f9e7d9f8 176EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
378932d3 177EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
f9e7d9f8 178
3f4ab627
JH
179# Line feed
180LF='
181'
182
a42643aa
JK
183# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
184# when case-folding filenames
185u200c=$(printf '\342\200\214')
186
378932d3 187export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
342e9ef2 188
e1970ce4
JH
189# Each test should start with something like this, after copyright notices:
190#
191# test_description='Description of this test...
192# This test checks if command xyzzy does the right thing...
193# '
194# . ./test-lib.sh
d5c1b7c2 195test "x$TERM" != "xdumb" && (
ca92a660
RH
196 test -t 1 &&
197 tput bold >/dev/null 2>&1 &&
198 tput setaf 1 >/dev/null 2>&1 &&
199 tput sgr0 >/dev/null 2>&1
200 ) &&
201 color=t
e1970ce4 202
e1970ce4
JH
203while test "$#" -ne 0
204do
205 case "$1" in
206 -d|--d|--de|--deb|--debu|--debug)
207 debug=t; shift ;;
886856ab
JH
208 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
209 immediate=t; shift ;;
5e2c08c6 210 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 211 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
0445e6f0
IB
212 -r)
213 shift; test "$#" -ne 0 || {
214 echo 'error: -r requires an argument' >&2;
215 exit 1;
216 }
217 run_list=$1; shift ;;
218 --run=*)
0ff74101 219 run_list=${1#--*=}; shift ;;
e1970ce4 220 -h|--h|--he|--hel|--help)
570f3226 221 help=t; shift ;;
e1970ce4
JH
222 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
223 verbose=t; shift ;;
ff09af3f 224 --verbose-only=*)
0ff74101 225 verbose_only=${1#--*=}
ff09af3f 226 shift ;;
1ece1274 227 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
228 # Ignore --quiet under a TAP::Harness. Saying how many tests
229 # passed without the ok/not ok details is always an error.
230 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
231 --with-dashes)
232 with_dashes=t; shift ;;
55db1df0 233 --no-color)
faa4bc35 234 color=; shift ;;
4e1be63c 235 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
236 valgrind=memcheck
237 shift ;;
238 --valgrind=*)
0ff74101 239 valgrind=${1#--*=}
952af351 240 shift ;;
5dfc368f 241 --valgrind-only=*)
0ff74101 242 valgrind_only=${1#--*=}
5dfc368f 243 shift ;;
44138559
JS
244 --tee)
245 shift ;; # was handled already
f423ef5f 246 --root=*)
0ff74101 247 root=${1#--*=}
f423ef5f 248 shift ;;
bb79af9d
JK
249 --chain-lint)
250 GIT_TEST_CHAIN_LINT=1
251 shift ;;
252 --no-chain-lint)
253 GIT_TEST_CHAIN_LINT=0
254 shift ;;
a136f6d8
JK
255 -x)
256 trace=t
257 verbose=t
258 shift ;;
452320f1
JK
259 --verbose-log)
260 verbose_log=t
261 shift ;;
e1970ce4 262 *)
1f729dca 263 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
264 esac
265done
266
26a07309 267if test -n "$valgrind_only"
5dfc368f
TR
268then
269 test -z "$valgrind" && valgrind=memcheck
270 test -z "$verbose" && verbose_only="$valgrind_only"
271elif test -n "$valgrind"
272then
273 verbose=t
274fi
952af351 275
ca92a660
RH
276if test -n "$color"
277then
d5c1b7c2
RH
278 # Save the color control sequences now rather than run tput
279 # each time say_color() is called. This is done for two
280 # reasons:
281 # * TERM will be changed to dumb
282 # * HOME will be changed to a temporary directory and tput
283 # might need to read ~/.terminfo from the original HOME
284 # directory to get the control sequences
285 # Note: This approach assumes the control sequences don't end
286 # in a newline for any terminal of interest (command
287 # substitutions strip trailing newlines). Given that most
288 # (all?) terminals in common use are related to ECMA-48, this
289 # shouldn't be a problem.
290 say_color_error=$(tput bold; tput setaf 1) # bold red
291 say_color_skip=$(tput setaf 4) # blue
292 say_color_warn=$(tput setaf 3) # brown/yellow
293 say_color_pass=$(tput setaf 2) # green
294 say_color_info=$(tput setaf 6) # cyan
295 say_color_reset=$(tput sgr0)
296 say_color_="" # no formatting for normal text
ca92a660 297 say_color () {
d5c1b7c2
RH
298 test -z "$1" && test -n "$quiet" && return
299 eval "say_color_color=\$say_color_$1"
ca92a660 300 shift
d5c1b7c2 301 printf "%s\\n" "$say_color_color$*$say_color_reset"
ca92a660
RH
302 }
303else
304 say_color() {
305 test -z "$1" && test -n "$quiet" && return
306 shift
307 printf "%s\n" "$*"
308 }
309fi
310
d5c1b7c2
RH
311TERM=dumb
312export TERM
313
55db1df0
PH
314error () {
315 say_color error "error: $*"
6e7b5aaf 316 GIT_EXIT_OK=t
55db1df0
PH
317 exit 1
318}
319
320say () {
321 say_color info "$*"
322}
323
614fe015
JK
324if test -n "$HARNESS_ACTIVE"
325then
326 if test "$verbose" = t || test -n "$verbose_only"
327 then
328 printf 'Bail out! %s\n' \
329 'verbose mode forbidden under TAP harness; try --verbose-log'
330 exit 1
331 fi
332fi
333
570f3226
MB
334test "${test_description}" != "" ||
335error "Test script did not set test_description."
336
337if test "$help" = "t"
338then
cb1aefda 339 printf '%s\n' "$test_description"
570f3226
MB
340 exit 0
341fi
342
4d9d62fa 343exec 5>&1
781f76b1 344exec 6<&0
452320f1
JK
345if test "$verbose_log" = "t"
346then
347 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
348elif test "$verbose" = "t"
e1970ce4
JH
349then
350 exec 4>&2 3>&1
351else
352 exec 4>/dev/null 3>/dev/null
353fi
354
d88785e4
JK
355# Send any "-x" output directly to stderr to avoid polluting tests
356# which capture stderr. We can do this unconditionally since it
357# has no effect if tracing isn't turned on.
358#
359# Note that this sets up the trace fd as soon as we assign the variable, so it
360# must come after the creation of descriptor 4 above. Likewise, we must never
361# unset this, as it has the side effect of closing descriptor 4, which we
362# use to show verbose tests to the user.
363#
364# Note also that we don't need or want to export it. The tracing is local to
365# this shell, and we would not want to influence any shells we exec.
366BASH_XTRACEFD=4
367
e1970ce4
JH
368test_failure=0
369test_count=0
41ac414e
JH
370test_fixed=0
371test_broken=0
2d84e9fb 372test_success=0
e1970ce4 373
d998bd4a
ÆAB
374test_external_has_tap=0
375
faa4bc35 376die () {
6e7b5aaf
CB
377 code=$?
378 if test -n "$GIT_EXIT_OK"
379 then
380 exit $code
381 else
382 echo >&5 "FATAL: Unexpected exit with code $code"
383 exit 1
384 fi
faa4bc35
CB
385}
386
6e7b5aaf 387GIT_EXIT_OK=
35641310 388trap 'die' EXIT
da706545 389trap 'exit $?' INT
41184273 390
12a29b1a
TR
391# The user-facing functions are loaded from a separate file so that
392# test_perf subshells can have them too
3c8f12c9 393. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 394
886856ab 395# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 396# the test_expect_* functions instead.
886856ab
JH
397
398test_ok_ () {
d5d9de1b 399 test_success=$(($test_success + 1))
633fe50a 400 say_color "" "ok $test_count - $@"
e1970ce4
JH
401}
402
886856ab 403test_failure_ () {
d5d9de1b 404 test_failure=$(($test_failure + 1))
633fe50a 405 say_color error "not ok $test_count - $1"
bf0dd8a8 406 shift
cb1aefda 407 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 408 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
409}
410
41ac414e 411test_known_broken_ok_ () {
41ac414e 412 test_fixed=$(($test_fixed+1))
633fe50a 413 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
414}
415
416test_known_broken_failure_ () {
41ac414e 417 test_broken=$(($test_broken+1))
633fe50a 418 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 419}
886856ab
JH
420
421test_debug () {
8e832ebc 422 test "$debug" = "" || eval "$1"
e1970ce4
JH
423}
424
e6a6ddc9
TR
425match_pattern_list () {
426 arg="$1"
427 shift
428 test -z "$*" && return 1
429 for pattern_
430 do
431 case "$arg" in
432 $pattern_)
433 return 0
434 esac
435 done
436 return 1
437}
438
0445e6f0
IB
439match_test_selector_list () {
440 title="$1"
441 shift
442 arg="$1"
443 shift
444 test -z "$1" && return 0
445
446 # Both commas and whitespace are accepted as separators.
447 OLDIFS=$IFS
448 IFS=' ,'
449 set -- $1
450 IFS=$OLDIFS
451
452 # If the first selector is negative we include by default.
453 include=
454 case "$1" in
455 !*) include=t ;;
456 esac
457
458 for selector
459 do
460 orig_selector=$selector
461
462 positive=t
463 case "$selector" in
464 !*)
465 positive=
466 selector=${selector##?}
467 ;;
468 esac
469
470 test -z "$selector" && continue
471
472 case "$selector" in
473 *-*)
474 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
475 then
476 echo "error: $title: invalid non-numeric in range" \
477 "start: '$orig_selector'" >&2
478 exit 1
479 fi
480 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
481 then
482 echo "error: $title: invalid non-numeric in range" \
483 "end: '$orig_selector'" >&2
484 exit 1
485 fi
486 ;;
487 *)
488 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
489 then
490 echo "error: $title: invalid non-numeric in test" \
491 "selector: '$orig_selector'" >&2
492 exit 1
493 fi
494 esac
495
496 # Short cut for "obvious" cases
497 test -z "$include" && test -z "$positive" && continue
498 test -n "$include" && test -n "$positive" && continue
499
500 case "$selector" in
501 -*)
502 if test $arg -le ${selector#-}
503 then
504 include=$positive
505 fi
506 ;;
507 *-)
508 if test $arg -ge ${selector%-}
509 then
510 include=$positive
511 fi
512 ;;
513 *-*)
514 if test ${selector%%-*} -le $arg \
515 && test $arg -le ${selector#*-}
516 then
517 include=$positive
518 fi
519 ;;
520 *)
521 if test $arg -eq $selector
522 then
523 include=$positive
524 fi
525 ;;
526 esac
527 done
528
529 test -n "$include"
530}
531
ff09af3f
TR
532maybe_teardown_verbose () {
533 test -z "$verbose_only" && return
534 exec 4>/dev/null 3>/dev/null
535 verbose=
536}
537
538last_verbose=t
539maybe_setup_verbose () {
540 test -z "$verbose_only" && return
26a07309 541 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
542 then
543 exec 4>&2 3>&1
544 # Emit a delimiting blank line when going from
545 # non-verbose to verbose. Within verbose mode the
546 # delimiter is printed by test_expect_*. The choice
547 # of the initial $last_verbose is such that before
548 # test 1, we do not print it.
549 test -z "$last_verbose" && echo >&3 ""
550 verbose=t
551 else
552 exec 4>/dev/null 3>/dev/null
553 verbose=
554 fi
555 last_verbose=$verbose
556}
557
5dfc368f
TR
558maybe_teardown_valgrind () {
559 test -z "$GIT_VALGRIND" && return
560 GIT_VALGRIND_ENABLED=
561}
562
563maybe_setup_valgrind () {
564 test -z "$GIT_VALGRIND" && return
26a07309 565 if test -z "$valgrind_only"
5dfc368f
TR
566 then
567 GIT_VALGRIND_ENABLED=t
568 return
569 fi
570 GIT_VALGRIND_ENABLED=
571 if match_pattern_list $test_count $valgrind_only
572 then
573 GIT_VALGRIND_ENABLED=t
574 fi
575}
576
9b5fe78b
JK
577want_trace () {
578 test "$trace" = t && test "$verbose" = t
579}
580
a136f6d8
JK
581# This is a separate function because some tests use
582# "return" to end a test_expect_success block early
583# (and we want to make sure we run any cleanup like
584# "set +x").
585test_eval_inner_ () {
586 # Do not add anything extra (including LF) after '$*'
587 eval "
9b5fe78b 588 want_trace && set -x
a136f6d8
JK
589 $*"
590}
591
a7c58f28 592test_eval_ () {
a136f6d8
JK
593 # We run this block with stderr redirected to avoid extra cruft
594 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
595 # the shell from printing the "set +x" to turn it off (nor the saving
596 # of $? before that). But we can make sure that the output goes to
597 # /dev/null.
598 #
599 # The test itself is run with stderr put back to &4 (so either to
600 # /dev/null, or to the original stderr if --verbose was used).
601 {
602 test_eval_inner_ "$@" </dev/null >&3 2>&4
603 test_eval_ret_=$?
9b5fe78b 604 if want_trace
a136f6d8
JK
605 then
606 set +x
607 if test "$test_eval_ret_" != 0
608 then
609 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
610 fi
611 fi
612 } 2>/dev/null
613 return $test_eval_ret_
a7c58f28
JN
614}
615
4d9d62fa 616test_run_ () {
b6b0afdc 617 test_cleanup=:
b586744a 618 expecting_failure=$2
bb79af9d 619
92b269f5 620 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
2a01ef8c
JK
621 # turn off tracing for this test-eval, as it simply creates
622 # confusing noise in the "-x" output
623 trace_tmp=$trace
624 trace=
bb79af9d
JK
625 # 117 is magic because it is unlikely to match the exit
626 # code of other programs
627 test_eval_ "(exit 117) && $1"
628 if test "$?" != 117; then
629 error "bug in the test script: broken &&-chain: $1"
630 fi
2a01ef8c 631 trace=$trace_tmp
bb79af9d
JK
632 fi
633
a57397b0 634 setup_malloc_check
a7c58f28 635 test_eval_ "$1"
b6b0afdc 636 eval_ret=$?
a57397b0 637 teardown_malloc_check
b586744a 638
a136f6d8
JK
639 if test -z "$immediate" || test $eval_ret = 0 ||
640 test -n "$expecting_failure" && test "$test_cleanup" != ":"
b586744a 641 then
1b3185fc 642 setup_malloc_check
a7c58f28 643 test_eval_ "$test_cleanup"
1b3185fc 644 teardown_malloc_check
b586744a 645 fi
1c0cc756
RJ
646 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
647 then
57e1538a
ÆAB
648 echo ""
649 fi
aa0bcf96 650 return "$eval_ret"
4d9d62fa
PR
651}
652
ae75342c 653test_start_ () {
8586f98b 654 test_count=$(($test_count+1))
ff09af3f 655 maybe_setup_verbose
5dfc368f 656 maybe_setup_valgrind
ae75342c
TR
657}
658
659test_finish_ () {
660 echo >&3 ""
5dfc368f 661 maybe_teardown_valgrind
ff09af3f 662 maybe_teardown_verbose
ae75342c
TR
663}
664
665test_skip () {
04ece593 666 to_skip=
ef2ac68d 667 skipped_reason=
e6a6ddc9
TR
668 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
669 then
670 to_skip=t
ef2ac68d 671 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 672 fi
05236a5e
JN
673 if test -z "$to_skip" && test -n "$test_prereq" &&
674 ! test_have_prereq "$test_prereq"
a7bb3940
JS
675 then
676 to_skip=t
ef2ac68d 677
07431fc8 678 of_prereq=
05236a5e 679 if test "$missing_prereq" != "$test_prereq"
07431fc8 680 then
05236a5e 681 of_prereq=" of $test_prereq"
07431fc8 682 fi
ef2ac68d
IB
683 skipped_reason="missing $missing_prereq${of_prereq}"
684 fi
0445e6f0
IB
685 if test -z "$to_skip" && test -n "$run_list" &&
686 ! match_test_selector_list '--run' $test_count "$run_list"
687 then
688 to_skip=t
689 skipped_reason="--run"
690 fi
07431fc8 691
ef2ac68d
IB
692 case "$to_skip" in
693 t)
633fe50a 694 say_color skip >&3 "skipping test: $@"
ef2ac68d 695 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
696 : true
697 ;;
698 *)
699 false
700 ;;
701 esac
702}
703
342e9ef2
TR
704# stub; perf-lib overrides it
705test_at_end_hook_ () {
706 :
707}
708
e1970ce4 709test_done () {
6e7b5aaf 710 GIT_EXIT_OK=t
2d84e9fb 711
1c0cc756
RJ
712 if test -z "$HARNESS_ACTIVE"
713 then
342e9ef2 714 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 715 mkdir -p "$test_results_dir"
dd78478f 716 base=${0##*/}
5c885c1b 717 test_results_path="$test_results_dir/${base%.sh}.counts"
8ef1abe5 718
5c885c1b 719 cat >"$test_results_path" <<-EOF
c54e6be7
ML
720 total $test_count
721 success $test_success
722 fixed $test_fixed
723 broken $test_broken
724 failed $test_failure
725
726 EOF
8ef1abe5 727 fi
41ac414e
JH
728
729 if test "$test_fixed" != 0
730 then
633fe50a 731 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
732 fi
733 if test "$test_broken" != 0
734 then
633fe50a 735 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
736 fi
737 if test "$test_broken" != 0 || test "$test_fixed" != 0
738 then
739 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
740 msg="remaining $test_remaining test(s)"
11d54b8b 741 else
b73d9a23 742 test_remaining=$test_count
11d54b8b 743 msg="$test_count test(s)"
41ac414e 744 fi
e1970ce4 745 case "$test_failure" in
10b94e28 746 0)
5099b99d 747 # Maybe print SKIP message
bf4b7219
RJ
748 if test -n "$skip_all" && test $test_count -gt 0
749 then
750 error "Can't use skip_all after running some tests"
751 fi
46f32a99 752 test -z "$skip_all" || skip_all=" # SKIP $skip_all"
5099b99d 753
1c0cc756
RJ
754 if test $test_external_has_tap -eq 0
755 then
b73d9a23 756 if test $test_remaining -gt 0
d87bd7c1 757 then
633fe50a 758 say_color pass "# passed all $msg"
d87bd7c1 759 fi
633fe50a 760 say "1..$test_count$skip_all"
d998bd4a 761 fi
abc5d372 762
4d0912a2
JH
763 if test -n "$remove_trash"
764 then
765 test -d "$remove_trash" ||
766 error "Tests passed but trash directory already removed before test cleanup; aborting"
df4c0d1a 767
4d0912a2
JH
768 cd "$(dirname "$remove_trash")" &&
769 rm -rf "$(basename "$remove_trash")" ||
770 error "Tests passed but test cleanup failed; aborting"
abc5d372 771
4d0912a2 772 fi
342e9ef2
TR
773 test_at_end_hook_
774
e1970ce4
JH
775 exit 0 ;;
776
777 *)
1c0cc756
RJ
778 if test $test_external_has_tap -eq 0
779 then
633fe50a
TR
780 say_color error "# failed $test_failure among $msg"
781 say "1..$test_count"
d998bd4a 782 fi
5099b99d 783
e1970ce4
JH
784 exit 1 ;;
785
786 esac
787}
788
e4597aae 789if test -n "$valgrind"
4e1be63c 790then
4e1be63c
JS
791 make_symlink () {
792 test -h "$2" &&
793 test "$1" = "$(readlink "$2")" || {
794 # be super paranoid
795 if mkdir "$2".lock
796 then
797 rm -f "$2" &&
798 ln -s "$1" "$2" &&
799 rm -r "$2".lock
800 else
801 while test -d "$2".lock
802 do
803 say "Waiting for lock on $2."
804 sleep 1
805 done
806 fi
807 }
808 }
809
810 make_valgrind_symlink () {
36bfb0e5 811 # handle only executables, unless they are shell libraries that
11d62145 812 # need to be in the exec-path.
36bfb0e5 813 test -x "$1" ||
11d62145 814 test "# " = "$(head -c 2 <"$1")" ||
36bfb0e5 815 return;
4e1be63c
JS
816
817 base=$(basename "$1")
28fab7b2
RS
818 case "$base" in
819 test-*)
820 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
821 ;;
822 *)
823 symlink_target="$GIT_BUILD_DIR/$base"
824 ;;
825 esac
4e1be63c
JS
826 # do not override scripts
827 if test -x "$symlink_target" &&
828 test ! -d "$symlink_target" &&
829 test "#!" != "$(head -c 2 < "$symlink_target")"
830 then
831 symlink_target=../valgrind.sh
832 fi
efd92ffd
JS
833 case "$base" in
834 *.sh|*.perl)
835 symlink_target=../unprocessed-script
836 esac
4e1be63c
JS
837 # create the link, or replace it if it is out of date
838 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
839 }
840
26a07309
TR
841 # override all git executables in TEST_DIRECTORY/..
842 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
843 mkdir -p "$GIT_VALGRIND"/bin
503e2241 844 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
26a07309
TR
845 do
846 make_valgrind_symlink $file
847 done
848 # special-case the mergetools loadables
849 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
850 OLDIFS=$IFS
851 IFS=:
852 for path in $PATH
853 do
854 ls "$path"/git-* 2> /dev/null |
855 while read file
ad0e6233 856 do
26a07309 857 make_valgrind_symlink "$file"
ad0e6233 858 done
26a07309
TR
859 done
860 IFS=$OLDIFS
4e1be63c
JS
861 PATH=$GIT_VALGRIND/bin:$PATH
862 GIT_EXEC_PATH=$GIT_VALGRIND/bin
863 export GIT_VALGRIND
952af351
TR
864 GIT_VALGRIND_MODE="$valgrind"
865 export GIT_VALGRIND_MODE
5dfc368f 866 GIT_VALGRIND_ENABLED=t
26a07309 867 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 868 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
869elif test -n "$GIT_TEST_INSTALLED"
870then
e4597aae
MO
871 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
872 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 873 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
874 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
875else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 876 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
877 if ! test -x "$git_bin_dir/git"
878 then
879 if test -z "$with_dashes"
880 then
e4597aae
MO
881 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
882 fi
883 with_dashes=t
884 fi
885 PATH="$git_bin_dir:$PATH"
6cec5c68 886 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
887 if test -n "$with_dashes"
888 then
6cec5c68 889 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 890 fi
4e1be63c 891fi
6cec5c68 892GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 893GIT_CONFIG_NOSYSTEM=1
3c995beb 894GIT_ATTR_NOSYSTEM=1
8f323c00 895export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 896
5e87eae9
JH
897if test -z "$GIT_TEST_CMP"
898then
899 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
900 then
901 GIT_TEST_CMP="$DIFF -c"
902 else
903 GIT_TEST_CMP="$DIFF -u"
904 fi
905fi
906
6cec5c68 907GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 908export GITPERLLIB
6cec5c68 909test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
910 error "You haven't built things yet, have you?"
911}
e1970ce4 912
e6e7530d 913if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
1c0cc756 914then
56cf9806 915 echo >&2 'You need to build test-chmtime:'
e6e7530d 916 echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
56cf9806
EW
917 exit 1
918fi
919
e1970ce4 920# Test repository
002d4ce8
JK
921TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
922test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
923case "$TRASH_DIRECTORY" in
924/*) ;; # absolute path is good
925 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 926esac
91c8b825 927test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 928rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 929 GIT_EXIT_OK=t
8d14ac94
JH
930 echo >&5 "FATAL: Cannot prepare test area"
931 exit 1
932}
933
90cff968 934HOME="$TRASH_DIRECTORY"
0ea47f9d
JH
935GNUPGHOME="$HOME/gnupg-home-not-used"
936export HOME GNUPGHOME
90cff968 937
1c0cc756
RJ
938if test -z "$TEST_NO_CREATE_REPO"
939then
38b074de 940 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 941else
38b074de 942 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 943fi
1bd9c648
LW
944# Use -P to resolve symlinks in our working directory so that the cwd
945# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 946cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 947
d5d9de1b
JS
948this_test=${0##*/}
949this_test=${this_test%%-*}
e6a6ddc9
TR
950if match_pattern_list "$this_test" $GIT_SKIP_TESTS
951then
952 say_color info >&3 "skipping test $this_test altogether"
953 skip_all="skip all tests in $this_test"
954 test_done
955fi
f17e9fbb 956
8648732e
BC
957# Provide an implementation of the 'yes' utility
958yes () {
959 if test $# = 0
960 then
961 y=y
962 else
963 y="$*"
964 fi
965
6129c930
JS
966 i=0
967 while test $i -lt 99
8648732e 968 do
6129c930
JS
969 echo "$y"
970 i=$(($i+1))
8648732e
BC
971 done
972}
973
f17e9fbb
JS
974# Fix some commands on Windows
975case $(uname -s) in
976*MINGW*)
977 # Windows has its own (incompatible) sort and find
978 sort () {
979 /usr/bin/sort "$@"
980 }
981 find () {
982 /usr/bin/find "$@"
983 }
5397ea31
JS
984 sum () {
985 md5sum "$@"
986 }
4114156a
JS
987 # git sees Windows-style pwd
988 pwd () {
989 builtin pwd -W
990 }
ee9fb68c 991 # no POSIX permissions
6fd1106a 992 # backslashes in pathspec are converted to '/'
fb9a2bea 993 # exec does not inherit the PID
a94114ad 994 test_set_prereq MINGW
5f4e02e5 995 test_set_prereq NATIVE_CRLF
a31d0665 996 test_set_prereq SED_STRIPS_CR
97669eed 997 test_set_prereq GREP_STRIPS_CR
4d715ac0 998 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
999 ;;
1000*CYGWIN*)
1001 test_set_prereq POSIXPERM
a31d0665 1002 test_set_prereq EXECKEEPSPID
cfa96496 1003 test_set_prereq CYGWIN
a31d0665 1004 test_set_prereq SED_STRIPS_CR
97669eed 1005 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
1006 ;;
1007*)
1008 test_set_prereq POSIXPERM
6fd1106a 1009 test_set_prereq BSLASHPSPEC
fb9a2bea 1010 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
1011 ;;
1012esac
704a3143 1013
b082687c 1014( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 1015test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 1016test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 1017test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 1018test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 1019
bb946bba 1020# Can we rely on git's output in the C locale?
30955229
JN
1021if test -n "$GETTEXT_POISON"
1022then
1023 GIT_GETTEXT_POISON=YesPlease
1024 export GIT_GETTEXT_POISON
5e9637c6 1025 test_set_prereq GETTEXT_POISON
30955229
JN
1026else
1027 test_set_prereq C_LOCALE_OUTPUT
1028fi
bb946bba 1029
cabdee2c
JH
1030# Use this instead of test_cmp to compare files that contain expected and
1031# actual output from git commands that can be translated. When running
1032# under GETTEXT_POISON this pretends that the command produced expected
1033# results.
1034test_i18ncmp () {
1035 test -n "$GETTEXT_POISON" || test_cmp "$@"
1036}
1037
127df8c6
JH
1038# Use this instead of "grep expected-string actual" to see if the
1039# output from a git command that can be translated either contains an
1040# expected string, or does not contain an unwanted one. When running
1041# under GETTEXT_POISON this pretends that the command produced expected
1042# results.
1043test_i18ngrep () {
1044 if test -n "$GETTEXT_POISON"
1045 then
1046 : # pretend success
1047 elif test "x!" = "x$1"
1048 then
1049 shift
1050 ! grep "$@"
1051 else
1052 grep "$@"
1053 fi
1054}
1055
20073274
AS
1056test_lazy_prereq PIPE '
1057 # test whether the filesystem supports FIFOs
9443605b 1058 case $(uname -s) in
a1f32964 1059 CYGWIN*|MINGW*)
9443605b
ML
1060 false
1061 ;;
1062 *)
1063 rm -f testfifo && mkfifo testfifo
1064 ;;
1065 esac
20073274
AS
1066'
1067
04083f27
JH
1068test_lazy_prereq SYMLINKS '
1069 # test whether the filesystem supports symbolic links
1070 ln -s x y && test -h y
1071'
c91cfd19 1072
b018c735
JN
1073test_lazy_prereq FILEMODE '
1074 test "$(git config --bool core.filemode)" = true
1075'
1076
ac39aa61
MG
1077test_lazy_prereq CASE_INSENSITIVE_FS '
1078 echo good >CamelCase &&
1079 echo bad >camelcase &&
1080 test "$(cat CamelCase)" != good
1081'
1082
5b0b5dd4
MG
1083test_lazy_prereq UTF8_NFD_TO_NFC '
1084 # check whether FS converts nfd unicode to nfc
1085 auml=$(printf "\303\244")
1086 aumlcdiar=$(printf "\141\314\210")
1087 >"$auml" &&
1088 case "$(echo *)" in
1089 "$aumlcdiar")
1090 true ;;
1091 *)
1092 false ;;
1093 esac
1094'
1095
09feffb6
JK
1096test_lazy_prereq AUTOIDENT '
1097 sane_unset GIT_AUTHOR_NAME &&
1098 sane_unset GIT_AUTHOR_EMAIL &&
1099 git var GIT_AUTHOR_IDENT
1100'
1101
6219bb22
JH
1102test_lazy_prereq EXPENSIVE '
1103 test -n "$GIT_TEST_LONG"
1104'
1105
e1ecd9e3
JH
1106test_lazy_prereq USR_BIN_TIME '
1107 test -x /usr/bin/time
1108'
1109
1767c517
JK
1110test_lazy_prereq NOT_ROOT '
1111 uid=$(id -u) &&
1112 test "$uid" != 0
1113'
1114
63b747ce
JT
1115test_lazy_prereq JGIT '
1116 type jgit
1117'
1118
719c3da2
JH
1119# SANITY is about "can you correctly predict what the filesystem would
1120# do by only looking at the permission bits of the files and
1121# directories?" A typical example of !SANITY is running the test
1122# suite as root, where a test may expect "chmod -r file && cat file"
1123# to fail because file is supposed to be unreadable after a successful
1124# chmod. In an environment (i.e. combination of what filesystem is
1125# being used and who is running the tests) that lacks SANITY, you may
1126# be able to delete or create a file when the containing directory
1127# doesn't have write permissions, or access a file even if the
1128# containing directory doesn't have read or execute permissions.
1129
f400e51c
TB
1130test_lazy_prereq SANITY '
1131 mkdir SANETESTD.1 SANETESTD.2 &&
1132
1133 chmod +w SANETESTD.1 SANETESTD.2 &&
1134 >SANETESTD.1/x 2>SANETESTD.2/x &&
1135 chmod -w SANETESTD.1 &&
719c3da2 1136 chmod -r SANETESTD.1/x &&
f400e51c
TB
1137 chmod -rx SANETESTD.2 ||
1138 error "bug in test sript: cannot prepare SANETESTD"
1139
719c3da2 1140 ! test -r SANETESTD.1/x &&
f400e51c
TB
1141 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1142 status=$?
1143
1144 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1145 rm -rf SANETESTD.1 SANETESTD.2 ||
1146 error "bug in test sript: cannot clean SANETESTD"
1147 return $status
1148'
f838ce58
JK
1149
1150GIT_UNZIP=${GIT_UNZIP:-unzip}
1151test_lazy_prereq UNZIP '
1152 "$GIT_UNZIP" -v
1153 test $? -ne 127
1154'
9a308de3
JK
1155
1156run_with_limited_cmdline () {
1157 (ulimit -s 128 && "$@")
1158}
1159
1160test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true'
6b9c38e1
JK
1161
1162build_option () {
1163 git version --build-options |
1164 sed -ne "s/^$1: //p"
1165}
1166
1167test_lazy_prereq LONG_IS_64BIT '
1168 test 8 -le "$(build_option sizeof-long)"
1169'